package tw.com.smsgo.example;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.TextView;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;


public class MainActivity extends Activity {
    public   final String TAG =  this.getClass().getSimpleName();
    RequestQueue queue;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // Instantiate the RequestQueue.
        queue = Volley.newRequestQueue(this);
        setContentView(R.layout.activity_main);

        final TextView content = (TextView) findViewById(R.id.msg_content);
        InputMethodManager imm = (InputMethodManager)getSystemService(
                Context.INPUT_METHOD_SERVICE);
        imm.hideSoftInputFromWindow(content.getWindowToken(), 0);


    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            Intent intent = new Intent(this, appSettings.class);
            this.startActivity(intent);
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onStop() {
        super.onStop();
        if (queue != null) {
            queue.cancelAll(TAG);
        }
    }
    private void hideKeyboard() {
        // Check if no view has focus:
        View view = this.getCurrentFocus();
        if (view != null) {
            InputMethodManager inputManager = (InputMethodManager) this.getSystemService(Context.INPUT_METHOD_SERVICE);
            inputManager.hideSoftInputFromWindow(view.getWindowToken(), InputMethodManager.HIDE_NOT_ALWAYS);
        }
    }
    public void send_message(View view) {

        hideKeyboard();
        final TextView destination = (TextView) findViewById(R.id.destination_id);
        final TextView content = (TextView) findViewById(R.id.msg_content);
        final TextView response_view = (TextView) findViewById(R.id.response_body);

        String url = "http://www.smsgo.com.tw/sms_gw/sendsms.aspx";
        HashMap<String, String> params = new HashMap<String, String>();
        SharedPreferences settings = getSharedPreferences("UserInfo", 0);

        params.put("api_key", settings.getString("api_key", ""));
        params.put("api_secret", settings.getString("api_secret", ""));


        params.put("to", destination.getText().toString());
        params.put("text", content.getText().toString());
        System.out.println("send: " + params.toString());
        //simpleRequest


        //Post Request

        StringRequest postRequest = new StringRequest(Request.Method.POST, url,
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String strresponse) {
                        // response

                        Log.d("Response", strresponse);
                        //{"result":{"msgid":-1,"statuscode":"-1","statusstr":"CGI string error!!","point":0}}
                        //convert string to json

                        try {
                            JSONObject response = new JSONObject(strresponse);
                            System.out.println("Response is : " + response.toString());
                            JSONObject result=response.getJSONObject("result");
                            String msgid=result.getString("msgid");
                            String statuscode=result.getString("statuscode");
                            String statusstr=result.getString("statusstr");
                           // JSONArray messages = response.getJSONArray("results");


                                response_view.setText(strresponse);


                        } catch (JSONException e) {
                            e.printStackTrace();
                        }



                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        // error
                        Log.d("Error.Response", error.toString());
                    }
                }
        ) {
            @Override
            protected Map<String, String> getParams() {
                HashMap<String, String> params = new HashMap<String, String>();
                SharedPreferences settings = getSharedPreferences("UserInfo", 0);
                //?rtype=JSON&username=&password=&msgid=1504200910420014
                params.put("username", settings.getString("api_key", ""));
                params.put("password", settings.getString("api_secret", ""));
                params.put("rtype", "JSON");

                //for sending
                params.put("encoding", "UCS2");
                params.put("dstaddr", destination.getText().toString());
                params.put("smbody", content.getText().toString());
                System.out.println("send: " + params.toString());


                return params;
            }
        };
        // Set the tag on the request.
        postRequest.setTag(TAG);
        //queue.add(postRequest);
        appSingleton.getInstance(this).addToRequestQueue(postRequest);


    }
}